#include "klipper.ch"

#define READONLY   TRUE
#define READWRITE  FALSE

FUNCTION main()

LOCAL    axAddress := {}
LOCAL    axProduct := {}

MEMVAR GetList


_Prepare()
_FScreen('_Scatter()/_Gather() Test','Press ESC to quit')
_Box(4,10,21,70)


USE address ALIAS address SHARED NEW
USE product ALIAS product SHARED NEW

while TRUE

    SELECT Address

    axAddress = _Scatter(READWRITE)



    SELECT Product
    GOTO BOTT

    axProduct = _Scatter(READONLY)


    @ 05,12 SAY 'ADDRESS INFO (Changes WILL be saved)'

    @ 06,12 SAY substr(axAddress[1,2]+space(10),1,10) GET axAddress[1,3]
    @ 07,12 SAY substr(axAddress[2,2]+space(10),1,10) GET axAddress[2,3]
    @ 08,12 SAY substr(axAddress[3,2]+space(10),1,10) GET axAddress[3,3]
    @ 09,12 SAY substr(axAddress[4,2]+space(10),1,10) GET axAddress[4,3]
    @ 10,12 SAY substr(axAddress[5,2]+space(10),1,10) GET axAddress[5,3]
    @ 11,12 SAY substr(axAddress[6,2]+space(10),1,10) GET axAddress[6,3]
    @ 12,12 SAY substr(axAddress[7,2]+space(10),1,10) GET axAddress[7,3]
    @ 13,12 SAY substr(axAddress[8,2]+space(10),1,10) GET axAddress[8,3]
    @ 14,12 SAY substr(axAddress[9,2]+space(10),1,10) GET axAddress[9,3]

    @ 16,12 say 'PRODUCT INFO (Changes will NOT be saved)'

    @ 17,12 SAY substr(axProduct[1,2]+space(10),1,10) GET axProduct[1,3]
    @ 18,12 SAY substr(axProduct[2,2]+space(10),1,10) GET axProduct[2,3]
    @ 19,12 SAY substr(axProduct[3,2]+space(10),1,10) GET axProduct[3,3]
    @ 20,12 SAY substr(axProduct[4,2]+space(10),1,10) GET axProduct[4,3]


    _ReadF()

    if lastkey() = 27
        exit
    endif


    * Notice that I have selected the wrong area for address replacement!
    * _Gather() will see to it that it replaces the data in the database
    * it came from regardless - this is due to the element n,SCAT_SRCE.
    * _Gather() will also attempt a record lock when it has to switch to
    * a new work area to find the target database.  If it cannot get it
    * immediately, a run-time error will occur - you have been warned!

    SELECT Product

    if rlock()
        _Gather(axAddress)
    endif

    SELECT Address

    if rlock()
        _Gather(axProduct)
    endif

end

RETURN(NIL)

